package com.doc.config.dbConfig;
import javax.sql.DataSource;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.boot.jdbc.DataSourceBuilder;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Primary;
import org.springframework.orm.jpa.JpaTransactionManager;
import org.springframework.transaction.PlatformTransactionManager;

@Configuration
public class DbConfig {
	@Bean(name = "primaryDataSource")
	@Primary
	@Qualifier("primaryDataSource")
	@ConfigurationProperties(prefix = "spring.datasource.primary")
	public DataSource getPrimaryDatasource() {
		DataSource s = DataSourceBuilder.create().build();
		return s;
	}
	@Bean(name = "MyJdbcTemplate")
	@Primary
	public MyJdbcTemplate primaryTemplate(@Qualifier("primaryDataSource") DataSource dataSource) {
		return new MyJdbcTemplate(dataSource);
	}
	@Bean(name = "transactionManager")
	@Primary
	public PlatformTransactionManager transcationManager(@Qualifier("primaryDataSource") DataSource dataSource) {
		JpaTransactionManager jpaTransactionManager = new JpaTransactionManager();
		jpaTransactionManager.setDataSource(dataSource);
		return jpaTransactionManager;
		// return new DataSourceTransactionManager(dataSource);
	}
}

